/* 
 E-xmms ver 1.0- A small xmms Epplet 
 Evan Songer <esonger@clarku.edu> 
 This is a GPL Licensed program, you know the deal. 
 --------------------------------------------------
 E-xmms ver 1.2
 Phil Warner <locutus@xmission.com>
 (see above GPL comment)
*/

#include <xmms/xmmsctrl.h> 
#include <sys/resource.h>
#include <epplet.h>

#define XMMS_PROG "xmms"

Epplet_gadget xmms_b, label, label2,  play_b,  pause_b, eject_b, prev_b, next_b, stop_b, close_b, vslider, hbar, play_label; //, play_title; 
 
extern void Epplet_redraw(void); 
 
char *xmmsprog = XMMS_PROG; 
int mp_pid = 0, len = 1, pos = 1, newpos = 1; 
int xmms_session = 0; 
 
static void xmms_cb(void *data); 
static void close_cb(void *data); 
static void play_cb(void); 
static void pause_cb(void);  
static void eject_cb(void); 
static void prev_cb(void);  
static void next_cb(void);  
static void stop_cb(void);   
static void slide_cb(void *data); 
static void run_cb(void *data);
static void in_cb(void *data, Window w);
static void out_cb(void *data, Window w);

int get_volume(void);
void set_volume(void);

int volume;
gboolean running;

static void in_cb(void *data, Window w) {
	if (!running) {
		Epplet_gadget_show(xmms_b);
	}
	Epplet_gadget_show(close_b);
	return;
}

static void out_cb(void *data, Window w) {
	if (!running) {
		Epplet_gadget_hide(xmms_b);
		Epplet_gadget_show(label);
	}
	Epplet_gadget_hide(close_b);
	return;
}

int get_volume(void)
{
	int vol;
	vol = xmms_remote_get_main_volume(xmms_session);
	volume = (100-vol)/5;
	//Epplet_gadget_data_changed(vslider);
	Epplet_timer((void*)get_volume, NULL, 0.05, "TIMER2"); 
}

void set_volume(void)
{
	int vol;
	vol = 100-(volume*5);
	xmms_remote_set_main_volume(xmms_session, vol);
}

static void
run_cb(void *data)
{
	running = xmms_remote_is_running(xmms_session);
	if (running){
		Epplet_gadget_hide(xmms_b);   
		Epplet_gadget_hide(label);   
		Epplet_gadget_hide(label2);   
		Epplet_gadget_show(play_b);   
		Epplet_gadget_show(play_label);   
		Epplet_gadget_show(pause_b);   
		Epplet_gadget_show(eject_b);   
		Epplet_gadget_show(prev_b);   
		Epplet_gadget_show(next_b);   
		Epplet_gadget_show(stop_b);   
		Epplet_gadget_show(vslider);   
		Epplet_gadget_show(hbar);   
	} else {
		Epplet_gadget_hide(play_b);   
		Epplet_gadget_hide(play_label);   
		Epplet_gadget_hide(pause_b);   
		Epplet_gadget_hide(eject_b);   
		Epplet_gadget_hide(prev_b);   
		Epplet_gadget_hide(next_b);   
		Epplet_gadget_hide(stop_b);   
		Epplet_gadget_hide(vslider);   
		Epplet_gadget_hide(hbar);   
		Epplet_gadget_show(label);    
	} 
	Epplet_timer(run_cb, NULL, 0.5, "TIMER1"); 
	data = NULL;
}

static void
slide_cb(void *data)
{
	char pos2[10];
	int m, s, temp;
	pos = xmms_remote_get_output_time(xmms_session);
	if (pos < 1)
		pos = 1;
	len = xmms_remote_get_playlist_time(xmms_session, xmms_remote_get_playlist_pos(xmms_session));
	if (len < 1 )
		len =1;
	newpos = (pos * 100) / len;
	temp = pos / 1000;
	m = temp / 60;
	s = temp - (m * 60);
	if (m < 10 && s < 10)
		sprintf(pos2, "0%li:0%li", m,s);
	else if (m < 10)
		sprintf(pos2, "0%li:%li", m,s);
	else if (s < 10)
		sprintf(pos2, "%li:0%li", m,s);
	else
		sprintf(pos2, "%li:%li", m,s);
	Epplet_change_label(play_label, pos2);
	Epplet_gadget_data_changed(hbar);
	Epplet_gadget_data_changed(vslider);
	Epplet_timer(slide_cb, NULL, 0.05, "TIMER");
	data = NULL;
}

static void
close_cb(void *data)
{
	Epplet_unremember();
	Esync();
	exit(0);
	data = NULL;
}

static void
xmms_cb(void *data)
{
	mp_pid = Epplet_spawn_command(xmmsprog);
	Epplet_gadget_show(label2);
	return;
	data = NULL;
}

static void play_cb(void)
{
	xmms_remote_play(xmms_session);
}

static void pause_cb(void) 
{ 
        xmms_remote_pause(xmms_session); 
}
static void eject_cb(void) 
{ 
        xmms_remote_eject(xmms_session); 
} 
static void prev_cb(void)  
{  
        xmms_remote_playlist_prev(xmms_session);  
}
static void next_cb(void)  
{  
        xmms_remote_playlist_next(xmms_session);  
}
static void stop_cb(void)  
{  
        xmms_remote_stop(xmms_session);
	
}

int 
main(int argc, char **argv)
{
	static char buf[1024];
	static char buf2[1024];
	int prio;
	gboolean started;
   	started = FALSE;

	prio = getpriority(PRIO_PROCESS, getpid());
	setpriority(PRIO_PROCESS, getpid(), prio + 10);
	atexit(Epplet_cleanup);

	Epplet_timer(slide_cb, NULL, 0.05, "TIMER");
	Epplet_timer(run_cb, NULL, 0.5, "TIMER1");
	Epplet_timer((void*)get_volume, NULL, 0.05, "TIMER2"); 
	Epplet_Init("E-Xmms", "1.0", "E Xmms epplet", 3, 3, argc, argv, 0);
	play_b = Epplet_create_button(NULL, NULL, 10, 22, 0, 0, "PLAY", 0, NULL, (void*)play_cb, NULL);
	pause_b = Epplet_create_button(NULL, NULL, 22, 22, 0, 0, "PAUSE", 0, NULL, (void*)pause_cb, NULL);
	eject_b = Epplet_create_button(NULL, NULL, 34, 22, 0, 0, "ARROW_UP", 0, NULL, (void*)eject_cb, NULL);
	prev_b = Epplet_create_button(NULL, NULL, 10, 34, 0, 0, "PREVIOUS", 0, NULL, (void*)prev_cb, NULL);
	next_b = Epplet_create_button(NULL, NULL, 22, 34, 0, 0, "NEXT", 0, NULL, (void*)next_cb, NULL);
	stop_b = Epplet_create_button(NULL, NULL, 34, 34, 0, 0, "STOP", 0, NULL, (void*)stop_cb, NULL);

	Esnprintf(buf, sizeof(buf), EROOT "/epplet_data/E-xmms/xmms-icon8.xpm");
	label =  Epplet_create_image(2, 2, 43, 43, buf);
	Esnprintf(buf2, sizeof(buf), EROOT "/epplet_data/E-xmms/xmms-icon8init.xpm");
	label2 =  Epplet_create_image(2, 2, 43, 43, buf2);

	xmms_b = Epplet_create_button(NULL, NULL, 22, 2, 0, 0, "SKIP", 0, NULL, xmms_cb, NULL); 
	close_b = Epplet_create_button(NULL, NULL, 34, 2, 0, 0, "CLOSE", 0, NULL, close_cb, NULL);
	vslider = Epplet_create_vslider(2, 2, 44, 0, 20, 1, 5, &volume, (void*)set_volume, NULL);
	play_label = Epplet_create_label(11, 3, "", 1);
	hbar = Epplet_create_hbar(11, 14, 35, 8, 0, &newpos);

	Epplet_register_focus_in_handler(in_cb, NULL);
	Epplet_register_focus_out_handler(out_cb, NULL);
       
	Epplet_gadget_show(label);

	Epplet_show();
	if (!started) {
		Epplet_remember();
		started = TRUE;
	}
	Epplet_Loop();

	return 0;
}
